/*
 * Copyright 2010-2015 JetBrains s.r.o.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jetbrains.kotlin.js.test.semantics;

import org.jetbrains.kotlin.js.test.SingleFileTranslationTest;

public final class ObjectTest extends SingleFileTranslationTest {

    public ObjectTest() {
        super("object/");
    }

    public void testObjectWithMethods() throws Exception {
        fooBoxTest();
    }

    public void testObjectDeclaration() throws Exception {
        fooBoxTest();
    }

    public void testObjectDeclarationWithVars() throws Exception {
        fooBoxTest();
    }

    public void testObjectInMethod() throws Exception {
        fooBoxTest();
    }

    public void testObjectInObject() throws Exception {
        fooBoxTest();
    }

    public void testObjectInheritingFromATrait() throws Exception {
        fooBoxTest();
    }

    public void testObjectInheritingFromClass() throws Exception {
        fooBoxTest();
    }

    public void testObjectInObjectWithClosure() throws Exception {
        fooBoxTest();
    }

    public void testLambdaInObjectInsideObject() throws Exception {
        checkFooBoxIsOk();
    }
}
